package org.processmining.causalactivitygraphcreator.algorithms;

import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.causalactivitygraphcreator.creators.GraphCreator;
import org.processmining.causalactivitygraphcreator.creators.GraphCreatorParameters;
import org.processmining.causalactivitygraphcreator.creators.impl.GraphZeroCreator;
import org.processmining.causalactivitygraphcreator.parameters.ConvertCausalActivityMatrixToCausalActivityGraphParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.framework.plugin.PluginContext;

public class ConvertCausalActivityMatrixToCausalActivityGraphAlgorithm {

	public CausalActivityGraph apply(PluginContext context, CausalActivityMatrix matrix,
			ConvertCausalActivityMatrixToCausalActivityGraphParameters parameters) {
		CausalActivityMatrix newMatrix = parameters.applyAll(matrix);
		GraphCreator creator = new GraphZeroCreator();
		GraphCreatorParameters creatorParameters = new GraphCreatorParameters();
		return creator.apply(context, newMatrix, creatorParameters);
	}
}
