package org.processmining.causalactivitygraphcreator.connections;

import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.causalactivitygraphcreator.parameters.ConvertCausalActivityMatrixToCausalActivityGraphParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.framework.connections.impl.AbstractConnection;

public class ConvertCausalActivityMatrixToCausalActivityGraphConnection extends AbstractConnection {

	public final static String MATRIX = "Matrix";
	public final static String GRAPH = "Graph";

	private ConvertCausalActivityMatrixToCausalActivityGraphParameters parameters;

	public ConvertCausalActivityMatrixToCausalActivityGraphConnection(CausalActivityMatrix matrix,
			CausalActivityGraph graph, ConvertCausalActivityMatrixToCausalActivityGraphParameters parameters) {
		super("Convert Causal Activity Matrix To Causal Activity Graph Connection");
		put(MATRIX, matrix);
		put(GRAPH, graph);
		this.parameters = new ConvertCausalActivityMatrixToCausalActivityGraphParameters(parameters);
	}

	public ConvertCausalActivityMatrixToCausalActivityGraphParameters getParameters() {
		return parameters;
	}
}
