package org.processmining.causalactivitygraphcreator.parameters;

import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.modifiers.CausalActivityMatrixModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixConcurrencyRatioModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixIncludeThresholdModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixStackedModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixZeroValueModifier;
import org.processmining.causalactivitymatrix.parameters.ModifyCausalActivityMatrixParameters;

public class ConvertCausalActivityMatrixToCausalActivityGraphParameters extends ModifyCausalActivityMatrixParameters {

	@Deprecated
	private boolean includeAll;

	public ConvertCausalActivityMatrixToCausalActivityGraphParameters() {
		super();
		// Deprecated
		setIncludeAll(false);
	}

	public ConvertCausalActivityMatrixToCausalActivityGraphParameters(ConvertCausalActivityMatrixToCausalActivityGraphParameters parameters) {
		super(parameters);
		// Deprecated
		setIncludeAll(parameters.isIncludeAll());
	}
	
	public CausalActivityMatrix applyAll(CausalActivityMatrix matrix) {
		CausalActivityMatrixModifier modifier = new CausalActivityMatrixStackedModifier(
				new CausalActivityMatrixZeroValueModifier(getZeroValue()),
				new CausalActivityMatrixConcurrencyRatioModifier(getConcurrencyRatio()),
				new CausalActivityMatrixIncludeThresholdModifier(getIncludeThreshold()));
		return modifier.apply(matrix);
	}

	@Deprecated
	public double correct(double fwd, double bwd) {
		double value = Math.abs(fwd - bwd) < getConcurrencyRatio() ? -1.0 : fwd;
		if (value == getZeroValue()) {
			return 0.0;
		} else if (value > getZeroValue()) {
			return value == 1.0 ? 1.0 : (value - getZeroValue()) / (1.0 - getZeroValue());
		} else {
			return value == -1.0 ? -1.0 : (value - getZeroValue()) / (1.0 + getZeroValue());
		}
	}

	public boolean equals(Object object) {
		if (object instanceof ConvertCausalActivityMatrixToCausalActivityGraphParameters) {
			ConvertCausalActivityMatrixToCausalActivityGraphParameters parameters = (ConvertCausalActivityMatrixToCausalActivityGraphParameters) object;
			return super.equals(parameters);
		}
		return false;
	}

	@Deprecated
	public void setIncludeAll(boolean includeAll) {
		this.includeAll = includeAll;
	}

	@Deprecated
	public boolean isIncludeAll() {
		return includeAll;
	}
}
